{$APPTYPE CONSOLE}

program sol_gg;
var
  a: array[1..31] of integer;
  C: array[0..31, 0..31] of integer;
  n: integer;
  odd, even: integer;
  res: integer;
  i, j: integer;

  procedure myassert(c: boolean);
  begin
    if (not c) then
      halt(1);
  end;

  function min(a, b: integer): integer;
  begin
    if (a < b) then
      Result := a
    else
      Result := b;
  end;

begin
  assign(input, 'input.txt');
  reset(input);
  assign(output, 'output.txt');
  rewrite(output);

  myassert(not SeekEof(input));
  read(n);
  myassert((1 <= n) and (n <= 31));
  for i := 1 to n do
  begin
    myassert(not SeekEof(input));
    read(a[i]);
    myassert((1 <= a[i]) and (a[i] <= 20));
  end;
  myassert(SeekEof(input));

  odd := 0;
  for i := 1 to n do
  begin
    if (a[i] mod 2 = 1) then
      inc(odd);
  end;
  even := n - odd;

  C[0, 0] := 1;
  for i := 1 to n do
  begin
    C[i, 0] := 1;
    for j := 1 to i-1 do
      C[i, j] := C[i-1, j] + C[i-1, j-1];
    C[i, i] := 1;
  end;

  res := 0;
  for i := 1 to odd do
  begin
    for j := 0 to min(i-1, even) do
      res := res + C[odd, i]*C[even, j];
  end;

  write(res);
  
  close(input);
  close(output);
end.